function SPLINEPLAY(modus)

is_ml = is_matlab;

if( is_ml )
   animate = 40;
else
   animate = 0;
end

MIN_VAL = -10;
MAX_VAL = 10;

MAX_NEW = 100;

NUM_INTERVAL = 2000;


if( nargin==0 )
   modus='1d';
end

if( strcmp(modus, '1d') )
   old_evals = zeros(1, NUM_INTERVAL);

   plot([MIN_VAL, MAX_VAL], [MIN_VAL, MAX_VAL], 'k+');
   title('1D-Spline : Maus-Links = Neuer Punkt; Maus-Rechts = Ende');
   hold on;

   x = zeros(MAX_NEW, 1);
   f = zeros(MAX_NEW, 1);

   act_pos = 0;

   while true

      [new_x, new_f, button] = ginput(1);

      if( button == 1 )
         act_pos = act_pos + 1;
         x(act_pos) = new_x;
         f(act_pos) = new_f;
      else
         break;
      end

      if( act_pos >= 2 )
         [x(1:act_pos), iperm] = sort(x(1:act_pos));
         temp = f(1:act_pos);
         f(1:act_pos) = temp(iperm);

         hold off;
         plot([MIN_VAL, MAX_VAL], [MIN_VAL, MAX_VAL], 'k+');
         title('1D-Spline : Maus-Links = Neuer Punkt; Maus-Rechts = Ende');
         hold on;

         spline = berechne_spline(x(1:act_pos), f(1:act_pos));

         interval = linspace(min(x(1:act_pos)), max(x(1:act_pos)), NUM_INTERVAL);
         evals = spline_auswerten(spline, interval);
         if( animate<=0 )
            evals = max(MIN_VAL, min(MAX_VAL, evals));
         end

         handle = plot(interval, evals, 'r-', 'LineWidth', 2);
         plot(x(1:act_pos), f(1:act_pos), 'b+', 'MarkerSize', 15, 'LineWidth', 1);

         if( animate>0 )
            set(handle, 'YDataSource', 'act_evals');

            for alpha=0:(1/animate):1
               act_evals = alpha*evals + (1-alpha)*old_evals;
               act_evals = max(MIN_VAL, min(MAX_VAL, act_evals));
               refreshdata(handle, 'caller');
               drawnow;
            end
         end

         old_evals = evals;
      end
   end

   close(gcf);

elseif( strcmp(modus, '2d') )
   old_evals_x = zeros(1, NUM_INTERVAL);
   old_evals_y = zeros(1, NUM_INTERVAL);

   plot([MIN_VAL, MAX_VAL], [MIN_VAL, MAX_VAL], 'k+');
   title('2D-Spline : Maus-Links = Neuer Punkt; Maus-Rechts = Ende');
   hold on;

   x = zeros(MAX_NEW, 1);
   y = zeros(MAX_NEW, 1);

   act_pos = 0;

   while true

      [new_x, new_y, button] = ginput(1);

      if( button == 1 )
         act_pos = act_pos + 1;
         x(act_pos) = new_x;
         y(act_pos) = new_y;
      else
         break;
      end

      if( act_pos >= 2 )
         hold off;
         plot([MIN_VAL, MAX_VAL], [MIN_VAL, MAX_VAL], 'k+');
         title('2D-Spline : Maus-Links = Neuer Punkt; Maus-Rechts = Ende');
         hold on;

         loc_ns = 1:act_pos;

         spline_x = berechne_spline(loc_ns, x(1:act_pos));
         spline_y = berechne_spline(loc_ns, y(1:act_pos));

         interval = linspace(1, act_pos, NUM_INTERVAL);

         evals_x = spline_auswerten(spline_x, interval);
         evals_y = spline_auswerten(spline_y, interval);

         if( animate<=0 )
            evals_x = max(MIN_VAL, min(MAX_VAL, evals_x));
            evals_y = max(MIN_VAL, min(MAX_VAL, evals_y));
         end

         handle = plot(evals_x, evals_y, 'r-', 'LineWidth', 2);
         plot(x(1:act_pos), y(1:act_pos), 'b+', 'MarkerSize', 15, 'LineWidth', 1);

         if( animate>0 )
            set(handle, 'XDataSource', 'act_evals_x');
            set(handle, 'YDataSource', 'act_evals_y');

            for alpha=0:(1/animate):1
               act_evals_x = alpha*evals_x + (1-alpha)*old_evals_x;
               act_evals_x = max(MIN_VAL, min(MAX_VAL, act_evals_x));

               act_evals_y = alpha*evals_y + (1-alpha)*old_evals_y;
               act_evals_y = max(MIN_VAL, min(MAX_VAL, act_evals_y));

               refreshdata(handle, 'caller');
               drawnow;
            end
         end

         old_evals_x = evals_x;
         old_evals_y = evals_y;
      end
   end

   close(gcf);

elseif( strcmp(modus, 'bezier') )

   old_evals_x = zeros(1, NUM_INTERVAL);
   old_evals_y = zeros(1, NUM_INTERVAL);

   plot([MIN_VAL, MAX_VAL], [MIN_VAL, MAX_VAL], 'k+');
   title('Bezier-Kurve : Maus-Links = Neuer Punkt; Maus-Rechts = Ende');
   hold on;

   x = zeros(MAX_NEW, 1);
   y = zeros(MAX_NEW, 1);

   act_pos = 0;

   while true

      [new_x, new_y, button] = ginput(1);

      if( button == 1 )
         act_pos = act_pos + 1;
         x(act_pos) = new_x;
         y(act_pos) = new_y;
      else
         break;
      end

      if( act_pos >= 2 )
         hold off;
         plot([MIN_VAL, MAX_VAL], [MIN_VAL, MAX_VAL], 'k+');
         title(['Bezier-Kurve ', num2str(act_pos),' : Maus-Links = Neuer Punkt; Maus-Rechts = Ende']);
         hold on;

         loc_ns = 1:act_pos;

         interval = linspace(0, 1, NUM_INTERVAL);

         bezi = de_casteljau([x(1:act_pos)'; y(1:act_pos)'], interval);

         evals_x = bezi(1, :);
         evals_y = bezi(2, :);

         if( animate<=0 )
            evals_x = max(MIN_VAL, min(MAX_VAL, evals_x));
            evals_y = max(MIN_VAL, min(MAX_VAL, evals_y));
         end

         handle = plot(evals_x, evals_y, 'r-', 'LineWidth', 2);
         plot(x(1:act_pos), y(1:act_pos), 'b--', 'MarkerSize', 15, 'LineWidth', 1);

         if( animate>0 )
            set(handle, 'XDataSource', 'act_evals_x');
            set(handle, 'YDataSource', 'act_evals_y');

            for alpha=0:(1/animate):1
               act_evals_x = alpha*evals_x + (1-alpha)*old_evals_x;
               act_evals_x = max(MIN_VAL, min(MAX_VAL, act_evals_x));

               act_evals_y = alpha*evals_y + (1-alpha)*old_evals_y;
               act_evals_y = max(MIN_VAL, min(MAX_VAL, act_evals_y));

               refreshdata(handle, 'caller');
               drawnow;
            end
         end

         old_evals_x = evals_x;
         old_evals_y = evals_y;
      end
   end

   close(gcf);



else
   % vgl. Schwarz/Koeckler : Numerische Mathematik, Seite 126

   A = 0;
   B = 2*pi*30;

   a = 5.03;
   b = 0.2;
   c = 2;
   d = 500;

   ts = linspace(A, B, 500)';
   rs = c*ts.*(1+b*c*ts/d.*sin(a*ts));

   tt = linspace(A, B, 10000)';

   spline = berechne_spline(ts, rs);
   rr = spline_auswerten(spline, tt);

   x1 = rs.*cos(ts);
   y1 = rs.*sin(ts);

   x2 = rr.*cos(tt);
   y2 = rr.*sin(tt);

   plot(x1, y1, 'k-', 'LineWidth', 2);
   title('Polygonzug');

   waitforbuttonpress;

   plot(x2, y2, 'r-');
   title('Spline');

end
